#!/bin/sh
. /opt/kelvpn/sbin/kelvpn_func.sh
. /opt/kelvpn/share/KelVPNCheck.conf

log_it "kelvpn_on_reconnect: reconfiguring routes & NAT after VPN reconnect..."

/opt/kelvpn/sbin/kelvpn_route.sh init

if [ "$KELVPN_MODE" = "hybrid" ]; then
    log_it "Mode=hybrid — running kelvpn_hybrid.sh all add"
    /opt/kelvpn/sbin/kelvpn_hybrid.sh all add
    sed -i 's/nameserver .*/nameserver 8.8.8.8/' /etc/resolv.conf
fi

if [ "$KELVPN_wlan1_MODE" = "full" ]; then
    log_it "wifi1_MODE=full — running kelvpn_route.sh add"
    /opt/kelvpn/sbin/kelvpn_route.sh add
fi

if [ "$KELVPN_MODE" = "hybrid" ]; then
    SUBNET="10.11.9.0/24"
    for IFACE in tun0 wan0; do
      if ! iptables -t nat -C POSTROUTING -s "$SUBNET" -o "$IFACE" -j MASQUERADE 2>/dev/null; then
        log_it_debug "Adding NAT MASQ for $SUBNET → $IFACE"
        iptables -t nat -A POSTROUTING -s "$SUBNET" -o "$IFACE" -j MASQUERADE
      fi
    done

    sh -c "iptables-save > /etc/iptables/rules.v4"
fi

log_it "kelvpn_on_reconnect: done."
